# -*- coding: utf-8 -*-
from django.core.management.base import BaseCommand, CommandError
from django.apps import apps


class Command(BaseCommand):
    help = 'python manage.py add_languages application_name model_name'

    def add_arguments(self, parser):
        parser.add_argument('app', type=str)
        parser.add_argument('model', type=str)

    def handle(self, *args, **options):

        json = [
            {"code": "aa", "title": "Afar"},
            {"code": "ab", "title": "Abkhazian"},
            {"code": "ae", "title": "Avestan"},
            {"code": "af", "title": "Afrikaans"},
            {"code": "ak", "title": "Akan"},
            {"code": "am", "title": "Amharic"},
            {"code": "an", "title": "Aragonese"},
            {"code": "ar", "title": "Arabic"},
            {"code": "as", "title": "Assamese"},
            {"code": "av", "title": "Avaric"},
            {"code": "ay", "title": "Aymara"},
            {"code": "az", "title": "Azerbaijani"},
            {"code": "ba", "title": "Bashkir"},
            {"code": "be", "title": "Belarusian"},
            {"code": "bg", "title": "Bulgarian"},
            {"code": "bh", "title": "Bihari languages"},
            {"code": "bi", "title": "Bislama"},
            {"code": "bm", "title": "Bambara"},
            {"code": "bn", "title": "Bengali"},
            {"code": "bo", "title": "Tibetan"},
            {"code": "br", "title": "Breton"},
            {"code": "bs", "title": "Bosnian"},
            {"code": "ca", "title": "Catalan; Valencian"},
            {"code": "ce", "title": "Chechen"},
            {"code": "ch", "title": "Chamorro"},
            {"code": "co", "title": "Corsican"},
            {"code": "cr", "title": "Cree"},
            {"code": "cs", "title": "Czech"},
            {"code": "cu", "title": "Church Slavic; Old Slavonic; Church Slavonic; Old Bulgarian; Old Church Slavonic"},
            {"code": "cv", "title": "Chuvash"},
            {"code": "cy", "title": "Welsh"},
            {"code": "da", "title": "Danish"},
            {"code": "de", "title": "German"},
            {"code": "dv", "title": "Divehi; Dhivehi; Maldivian"},
            {"code": "dz", "title": "Dzongkha"},
            {"code": "ee", "title": "Ewe"},
            {"code": "el", "title": "Greek, Modern (1453-)"},
            {"code": "en", "title": "English"},
            {"code": "eo", "title": "Esperanto"},
            {"code": "es", "title": "Spanish; Castilian"},
            {"code": "et", "title": "Estonian"},
            {"code": "eu", "title": "Basque"},
            {"code": "fa", "title": "Persian"},
            {"code": "ff", "title": "Fulah"},
            {"code": "fi", "title": "Finnish"},
            {"code": "fj", "title": "Fijian"},
            {"code": "fo", "title": "Faroese"},
            {"code": "fr", "title": "French"},
            {"code": "fy", "title": "Western Frisian"},
            {"code": "ga", "title": "Irish"},
            {"code": "gd", "title": "Gaelic; Scottish Gaelic"},
            {"code": "gl", "title": "Galician"},
            {"code": "gn", "title": "Guarani"},
            {"code": "gu", "title": "Gujarati"},
            {"code": "gv", "title": "Manx"},
            {"code": "ha", "title": "Hausa"},
            {"code": "he", "title": "Hebrew"},
            {"code": "hi", "title": "Hindi"},
            {"code": "ho", "title": "Hiri Motu"},
            {"code": "hr", "title": "Croatian"},
            {"code": "ht", "title": "Haitian; Haitian Creole"},
            {"code": "hu", "title": "Hungarian"},
            {"code": "hy", "title": "Armenian"},
            {"code": "hz", "title": "Herero"},
            {"code": "ia", "title": "Interlingua (International Auxiliary Language Association)"},
            {"code": "id", "title": "Indonesian"},
            {"code": "ie", "title": "Interlingue; Occidental"},
            {"code": "ig", "title": "Igbo"},
            {"code": "ii", "title": "Sichuan Yi; Nuosu"},
            {"code": "ik", "title": "Inupiaq"},
            {"code": "io", "title": "Ido"},
            {"code": "is", "title": "Icelandic"},
            {"code": "it", "title": "Italian"},
            {"code": "iu", "title": "Inuktitut"},
            {"code": "ja", "title": "Japanese"},
            {"code": "jv", "title": "Javanese"},
            {"code": "ka", "title": "Georgian"},
            {"code": "kg", "title": "Kongo"},
            {"code": "ki", "title": "Kikuyu; Gikuyu"},
            {"code": "kj", "title": "Kuanyama; Kwanyama"},
            {"code": "kk", "title": "Kazakh"},
            {"code": "kl", "title": "Kalaallisut; Greenlandic"},
            {"code": "km", "title": "Central Khmer"},
            {"code": "kn", "title": "Kannada"},
            {"code": "ko", "title": "Korean"},
            {"code": "kr", "title": "Kanuri"},
            {"code": "ks", "title": "Kashmiri"},
            {"code": "ku", "title": "Kurdish"},
            {"code": "kv", "title": "Komi"},
            {"code": "kw", "title": "Cornish"},
            {"code": "ky", "title": "Kirghiz; Kyrgyz"},
            {"code": "la", "title": "Latin"},
            {"code": "lb", "title": "Luxembourgish; Letzeburgesch"},
            {"code": "lg", "title": "Ganda"},
            {"code": "li", "title": "Limburgan; Limburger; Limburgish"},
            {"code": "ln", "title": "Lingala"},
            {"code": "lo", "title": "Lao"},
            {"code": "lt", "title": "Lithuanian"},
            {"code": "lu", "title": "Luba-Katanga"},
            {"code": "lv", "title": "Latvian"},
            {"code": "mg", "title": "Malagasy"},
            {"code": "mh", "title": "Marshallese"},
            {"code": "mi", "title": "Maori"},
            {"code": "mk", "title": "Macedonian"},
            {"code": "ml", "title": "Malayalam"},
            {"code": "mn", "title": "Mongolian"},
            {"code": "mr", "title": "Marathi"},
            {"code": "ms", "title": "Malay"},
            {"code": "mt", "title": "Maltese"},
            {"code": "my", "title": "Burmese"},
            {"code": "na", "title": "Nauru"},
            {"code": "nb", "title": "Bokmål, Norwegian; Norwegian Bokmål"},
            {"code": "nd", "title": "Ndebele, North; North Ndebele"},
            {"code": "ne", "title": "Nepali"},
            {"code": "ng", "title": "Ndonga"},
            {"code": "nl", "title": "Dutch; Flemish"},
            {"code": "nn", "title": "Norwegian Nynorsk; Nynorsk, Norwegian"},
            {"code": "no", "title": "Norwegian"},
            {"code": "nr", "title": "Ndebele, South; South Ndebele"},
            {"code": "nv", "title": "Navajo; Navaho"},
            {"code": "ny", "title": "Chichewa; Chewa; Nyanja"},
            {"code": "oc", "title": "Occitan (post 1500); Provençal"},
            {"code": "oj", "title": "Ojibwa"},
            {"code": "om", "title": "Oromo"},
            {"code": "or", "title": "Oriya"},
            {"code": "os", "title": "Ossetian; Ossetic"},
            {"code": "pa", "title": "Panjabi; Punjabi"},
            {"code": "pi", "title": "Pali"},
            {"code": "pl", "title": "Polish"},
            {"code": "ps", "title": "Pushto; Pashto"},
            {"code": "pt", "title": "Portuguese"},
            {"code": "qu", "title": "Quechua"},
            {"code": "rm", "title": "Romansh"},
            {"code": "rn", "title": "Rundi"},
            {"code": "ro", "title": "Romanian; Moldavian; Moldovan"},
            {"code": "ru", "title": "Russian"},
            {"code": "rw", "title": "Kinyarwanda"},
            {"code": "sa", "title": "Sanskrit"},
            {"code": "sc", "title": "Sardinian"},
            {"code": "sd", "title": "Sindhi"},
            {"code": "se", "title": "Northern Sami"},
            {"code": "sg", "title": "Sango"},
            {"code": "si", "title": "Sinhala; Sinhalese"},
            {"code": "sk", "title": "Slovak"},
            {"code": "sl", "title": "Slovenian"},
            {"code": "sm", "title": "Samoan"},
            {"code": "sn", "title": "Shona"},
            {"code": "so", "title": "Somali"},
            {"code": "sq", "title": "Albanian"},
            {"code": "sr", "title": "Serbian"},
            {"code": "ss", "title": "Swati"},
            {"code": "st", "title": "Sotho, Southern"},
            {"code": "su", "title": "Sundanese"},
            {"code": "sv", "title": "Swedish"},
            {"code": "sw", "title": "Swahili"},
            {"code": "ta", "title": "Tamil"},
            {"code": "te", "title": "Telugu"},
            {"code": "tg", "title": "Tajik"},
            {"code": "th", "title": "Thai"},
            {"code": "ti", "title": "Tigrinya"},
            {"code": "tk", "title": "Turkmen"},
            {"code": "tl", "title": "Tagalog"},
            {"code": "tn", "title": "Tswana"},
            {"code": "to", "title": "Tonga (Tonga Islands)"},
            {"code": "tr", "title": "Turkish"},
            {"code": "ts", "title": "Tsonga"},
            {"code": "tt", "title": "Tatar"},
            {"code": "tw", "title": "Twi"},
            {"code": "ty", "title": "Tahitian"},
            {"code": "ug", "title": "Uighur; Uyghur"},
            {"code": "uk", "title": "Ukrainian"},
            {"code": "ur", "title": "Urdu"},
            {"code": "uz", "title": "Uzbek"},
            {"code": "ve", "title": "Venda"},
            {"code": "vi", "title": "Vietnamese"},
            {"code": "vo", "title": "Volapük"},
            {"code": "wa", "title": "Walloon"},
            {"code": "wo", "title": "Wolof"},
            {"code": "xh", "title": "Xhosa"},
            {"code": "yi", "title": "Yiddish"},
            {"code": "yo", "title": "Yoruba"},
            {"code": "za", "title": "Zhuang; Chuang"},
            {"code": "zh", "title": "Chinese"},
            {"code": "zu", "title": "Zulu"}
        ]

        try:
            lang_model = apps.get_model(
                options['app'], options['model'])
            if lang_model.is_langlink_model:
                for lang in json:
                    try:
                        new_lang = lang_model(
                            **{'code': lang['code'], 'title': lang['title']})
                        new_lang.save()
                        print('%s is added to \'%s\' model' % (
                            lang['title'], options['model']))
                    except:
                        # The language code is already exist
                        pass
            else:
                raise CommandError(
                    '%s is not a language model' % options['model'])

        except AttributeError:
            raise CommandError("%s is not a language model" % options['model'])

        except LookupError, e:
            raise CommandError(str(e))
